////////////////////////////////////////////////////////////
//
//  HC_SCAN.H - Hemicube Scan Conversion Class
//
//  Version:    1.03B
//
//  History:    94/08/23 - Version 1.00A release.
//              94/12/16 - Version 1.01A release.
//              95/02/05 - Version 1.02A release.
//              95/07/21 - Version 1.02B release.
//              96/02/14 - Version 1.02C release.
//              96/04/01 - Version 1.03A release.
//              97/04/01 - Version 1.03B release.
//
//  Compilers:  Microsoft Visual C/C++ Professional V5.0
//              Borland C++ Version 5.0
//
//  Author:     Ian Ashdown, P.Eng.
//              byHeart Consultants Limited
//              620 Ballantree Road
//              West Vancouver, B.C.
//              Canada V7S 1W3
//              Tel. (604) 922-6148
//              Fax. (604) 987-7621
//
//  Copyright 1994-2002 byHeart Consultants Limited
//
//  The following source code has been derived from:
//
//    Ashdown, I. 1994. Radiosity: A Programmer's
//    Perspective. New York, NY: John Wiley & Sons.
//
//  It may be freely copied, redistributed, and/or modified
//  for personal use ONLY, as long as the copyright notice
//  is included with all source code files.
//
////////////////////////////////////////////////////////////

#ifndef _HC_SCAN_H
#define _HC_SCAN_H

#include "ff_scan.h"
#include "hc_delta.h"

// Hemicube polygon scan conversion
class HemiScan : public FormScan
{
  private:
    HemiDelta dff;      // Delta form factors

  public:
    HemiScan();

    ~HemiScan();

    void InitBuffer();
    void DrawEdgeList();
    void SumDeltas( float *, int );
};

#endif

